#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>

#include "integer.h"
#include "fstr.h"
#include "lcd_io.h"
#include "tchscrn_io.h"
#include "button.h"



static BUTTON* bt_list[21]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


static void bt_clr (BYTE bt)
{
	BYTE i;

	for(i=0; (bt_list[i]->cmd != bt) && (i < 20)  ; i++); 
	if ( i < 20)
		{
		lcd_output(bt_list[i]->rt, bt_list[i]->ct, bt_list[i]->c2 - bt_list[i]->ct, "", bt_list[i]->clr, bt_list[i]->fon);
		lcd_square(bt_list[i]->r1, bt_list[i]->c1, bt_list[i]->r2, bt_list[i]->c2, 0x0000, 0, 0);
		}
}

static void bt_viwe (BYTE bt)
{
	BYTE i, br;

	for(i=0; (bt_list[i]->cmd != bt) && (i < 20)  ; i++); 
	if ( i < 20) 
		{
		br=(bt_list[i]->fon == 0)? 0: 4;
		lcd_square(bt_list[i]->r1, bt_list[i]->c1, bt_list[i]->r2, bt_list[i]->c2, bt_list[i]->fon, br, br);
		lcd_output(bt_list[i]->rt, bt_list[i]->ct, bt_list[i]->c2 - bt_list[i]->ct, bt_list[i]->ttl, bt_list[i]->clr, bt_list[i]->fon);
		}
}



void bt_lstadd(BUTTON* bt)
{
	BYTE i;

	for(i=0; bt_list[i] ; i++)
		if( bt->cmd == bt_list[i]->cmd) return; 
	bt_list[i]=bt;
}

void bt_lstrem(BYTE bt)
{
	BYTE i;

	for(i=0; (bt_list[i]->cmd != bt) && (i < 20)  ; i++); 
	if ( i < 20) 
		{
		bt_clr (bt);
		bt_list[i]=0;
		}
}


BYTE bt_press()
{
	BYTE i;
	BYTE bt;
	int c,r;
	
	c=tchscrn_readec();
	r=tchscrn_reader();
	if ((c== -1) || (r == -1)) return 0;

	for(i=0; i < 20; i++) 
		if (bt_list[i]) 
			{
			bt=bt_list[i]->cmd;
			if ((bt_list[i]->r1 <= r) && ( r <= bt_list[i]->r2) && (bt_list[i]->c1 <= c) && ( c <= bt_list[i]->c2)) 
				return bt_list[i]->cmd;
			}
	return 0;
}

void bt_lstviwe()
{
	BYTE i;
	
	for(i=0; i < 20; i++) 
		if (bt_list[i]) 
			bt_viwe(bt_list[i]->cmd);
}

void bt_lstttl(BYTE bt, BYTE *ttl)
{
	BYTE i;
	
	for(i=0; (bt_list[i]->cmd != bt) && (i < 20)  ; i++); 
	if ( i < 20) 
		{
		strncpy(bt_list[i]->ttl,ttl,40); 
		bt_viwe(bt_list[i]->cmd);
		}
}			

static void bt_lstcolor(BYTE bt, UINT clr)
{
	BYTE i;
	
	for(i=0; (bt_list[i]->cmd != bt) && (i < 20)  ; i++); 
	if ( i < 20) 
		{
		bt_list[i]->clr=clr; 
		bt_viwe(bt_list[i]->cmd);
		}
}			



void bt_lstclr()
{
	BYTE i;

	for(i=0; i < 20; i++) 
		if( bt_list[i] )
			bt_lstrem(bt_list[i]->cmd);

	for(i=0; i < 20; i++) 
		bt_list[i]=0;
}


#define RD    0b1111100000000000


static BYTE blnk_cnt, blnk_inv;
void bt_NoLink()
{
	blnk_cnt++; /*    */
	if(blnk_cnt == 1)
		{
		blnk_cnt=0;
		blnk_inv=(blnk_inv)? 0:1;
		if (blnk_inv) 
			bt_lstcolor(bsl_lnk, RD);
		else
			bt_lstcolor(bsl_lnk, 0);
		}
}
void bt_OnLink()
{
	blnk_cnt=0;
	blnk_inv=0;
	bt_viwe(bsl_lnk);
	bt_lstcolor(bsl_lnk, 0);
}
