#include <avr/io.h>
#include "integer.h"

#include "crc8.h"

/*
  Name  : CRC-8
  Poly  : 0x31    x^8 + x^5 + x^4 + 1
  Init  : 0xFF
  Revert: false
  XorOut: 0x00
  Check : 0xF7 ("123456789")
  MaxLen: 15 (127 ) - 
    , ,     
*/

UINT Crc8(BYTE *pcBlock, UINT len)
{
    BYTE crc = 0xFF;
    BYTE i;
 
    while (len--)
    {
        crc ^= *pcBlock++;
 
        for (i = 0; i < 8; i++)
            crc = crc & 0x80 ? (crc << 1) ^ 0x31 : crc << 1;
    }
 
    return crc;
}

