#include <avr/io.h>
#include "integer.h"
#include "gen.h"


static void ConfigTimer (DWORD rate)
{
	/* Configure timer. */
	TCC1.PER 		= (UINT) (rate/1024/1000);
	TCC1.CTRLB 		= TC_WGMODE_NORMAL_gc;
	TCC1.INTCTRLA 	= TC_OVFINTLVL_LO_gc;
	TCC1.CTRLA 		= TC_CLKSEL_DIV1024_gc;

	TCC0.CTRLB 		= TC_WGMODE_NORMAL_gc;
	TCC0.CTRLA 		= TC_CLKSEL_OFF_gc;
	TCC0.CTRLC 		= 0;
	TCC0.CTRLD 		= 0;
	TCC0.CCA 		= (UINT) (rate/8/2/38000);


}

void ConfigClockSystem2M( void )
{
	/* Start internal oscillator. */
	OSC.CTRL = OSC_RC2MEN_bm;


	do {
		/* Wait while oscillator stabilizes. */
	} while ( ( OSC.STATUS & OSC_RC2MRDY_bm ) == 0 );

	/* Select internal as master clock. */
	
	CCP = CCP_IOREG_gc;
	CLK.CTRL = CLK_SCLKSEL_RC2M_gc;

	ConfigTimer(2000000);
}

void ConfigClockSystem32M( void )
{
	/* Start internal oscillator. */
	OSC.CTRL = OSC_RC32MEN_bm;


	do {
		/* Wait while oscillator stabilizes. */
	} while ( ( OSC.STATUS & OSC_RC32MRDY_bm ) == 0 );

	/* Select internal as master clock. */
	
	CCP = CCP_IOREG_gc;
	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;

	ConfigTimer(32000000UL);

}






