#include <avr/io.h>

#include "integer.h"
#include "lcd_io.h"
#include "irda_io.h"
#include "plist.h"


#define SRTROW 45
#define WDHROW 25

static BYTE plist_empty[MAXROW];
static BYTE plist_wndw;
static BYTE plist_name[MAXROW][65];
static BYTE plist_type[MAXROW];
static DWORD plist_size[MAXROW];


static BYTE fldr[]= {  243, 0};
static BYTE empt[]= {  242, 0};

static UINT trc_clr 	= 0b0000000000011111;
static UINT fld_clr 	= 0b1111111111100000;
static UINT fnt_clr 	= 0b1111111111111111;
static UINT fon_unsclr 	= 0b0000000000000000;
static UINT fon_selclr 	= 0b0000010111110111;

static void plist_outitem(pos,inv)
{
	UINT fnt, fon;


	fon = (inv)? fon_selclr: fon_unsclr;

	if (plist_empty[pos])
		{ 
		lcd_output(SRTROW+pos*WDHROW,  5,  22,"",0,0);
		lcd_output(SRTROW+pos*WDHROW, 27, 292,"",0,0);
		return;
		}

	if (!plist_type[pos]) 
		lcd_output(SRTROW+pos*WDHROW,5,22,fldr,fld_clr,fon);
	else	
		lcd_output(SRTROW+pos*WDHROW,5,22,empt,trc_clr,fon);
		
	lcd_output(SRTROW+pos*WDHROW, 27, 292, plist_name[pos],fnt_clr, fon);

}



void plist_strtitem(BYTE pos)
{
	plist_wndw=pos;
}

void plist_viewitem(BYTE pos)
{
	BYTE *nm;

	pos-=plist_wndw;
	if ( pos >=MAXROW ) return;
	nm=	plist_name[pos];
	irda_rcvitem(&plist_type[pos],nm,&plist_size[pos]);
	plist_empty[pos]=0;
	plist_outitem(pos,0);
}





static BYTE cur_pos;
void plist_selitem(BYTE pos)
{
	BYTE i,j;
	BYTE *nm;

//	if (plist_empty[pos]) return;


	if((pos < plist_wndw )||( pos >= plist_wndw+MAXROW ))
		{
		while( pos < plist_wndw )
			{
			for(i=MAXROW-1; i ; i--)
				{		
				plist_type[i]=plist_type[i-1];
				for(j=0; j < 65; j++) plist_name[i][j]=plist_name[i-1][j];
				plist_size[i]=plist_size[i-1];
				plist_empty[i]=plist_empty[i-1];
				plist_outitem(i,0);
				}
			for(j=0; j < 65; j++) plist_name[0][j]=0;
			plist_outitem(0,1);
			plist_wndw--;
			} 
		while( pos >= plist_wndw+MAXROW )
			{
			for(i=0; i < MAXROW-1 ; i++)
				{		
				plist_type[i]=plist_type[i+1];
				for(j=0; j < 65; j++) plist_name[i][j]=plist_name[i+1][j]; 
				plist_size[i]=plist_size[i+1];
				plist_empty[i]=plist_empty[i+1];
				plist_outitem(i,0);
				}
			for(j=0; j < 65; j++) plist_name[MAXROW-1][j]=0;
			plist_outitem(MAXROW-1,1);
			plist_wndw++;
			} 
		cur_pos=pos-plist_wndw;
		nm=	plist_name[cur_pos];
		irda_rcvitem(&plist_type[cur_pos],nm,&plist_size[cur_pos]);
		plist_empty[cur_pos]=0;
		}
	else
		{
		plist_outitem(cur_pos,0);
		cur_pos=pos-plist_wndw;
		}
	plist_outitem(cur_pos,1);


}


void plist_clr()
{
	BYTE i,r;

	plist_wndw=0;
	for(r=0; r < MAXROW; r++)
		{
		plist_type[i]=0;
		for(i=0; i < 65;i++) plist_name[r][i]=0;
		plist_size[r]=0;
		plist_empty[r]=1;
		plist_outitem(r,0);
		}
}


