#include "port_cnfg.h"

#include <avr/io.h>
#include <avr/interrupt.h>
#include "integer.h"

void port_initialize(void)
{

	PR.PRGEN = PR_AES_bm | PR_EBI_bm | PR_RTC_bm;
	
//	/*  A -    LD (I/O), */
//	PORTA_DIR  		= 0b11111111;
//	PORTA_PIN0CTRL	= PORT_SRLEN_bm; 	
//	PORTA_PIN1CTRL	= PORT_SRLEN_bm; 	
//	PORTA_PIN2CTRL	= PORT_SRLEN_bm;	
//	PORTA_PIN3CTRL	= PORT_SRLEN_bm;
//	PORTA_PIN4CTRL	= PORT_SRLEN_bm; 
//	PORTA_PIN5CTRL	= PORT_SRLEN_bm; 
//	PORTA_PIN6CTRL	= PORT_SRLEN_bm; 
//	PORTA_PIN7CTRL	= PORT_SRLEN_bm; 
//	PORTA_OUT 		= 0b00000000; 
//
//	PR.PRPA= PR_AC_bm;	

	/*  A - RESET LCD,   , BV, LB */
	PORTA_DIR  		= 0b00000010;
	PORTA_OUT 		= 0b00000010; 
	PORTA_INTCTRL	= PORT_INT0LVL_LO_gc  | PORT_INT1LVL_LO_gc;

//	/*  B -   */
	PORTB_DIR  		= 0b00000000;
	PORTB_OUT 		= 0b00000000; 


	/*  C - IrDA*/
	PORTC_OUT 		= 0b00001000;
	PORTC_DIR  		= 0b00001010;
	PORTC_PIN1CTRL	= PORT_SRLEN_bm;					/* F  */
	PORTC_PIN2CTRL	= PORT_OPC_PULLUP_gc;				/* Rx */
	PORTC_PIN3CTRL	= PORT_SRLEN_bm | PORT_INVEN_bm;	/* Tx */
	PORTC_INTCTRL	= PORT_INT0LVL_LO_gc  | PORT_INT1LVL_LO_gc;

	PR.PRPC			= PR_SPI_bm | PR_TWI_bm ;	
	

	/*  D - LED, LCD */
	PORTD_DIR  		= 0b11111111;
	PORTD_PIN0CTRL	= PORT_SRLEN_bm; /* LED1 */		
	PORTD_PIN1CTRL	= PORT_SRLEN_bm; /* LED2 */		
	PORTD_PIN2CTRL	= PORT_SRLEN_bm; /* LED3 */		
	PORTD_PIN3CTRL	= PORT_SRLEN_bm; /* LED4 */		
	PORTD_PIN4CTRL	= PORT_SRLEN_bm; /* CS 	 */		
	PORTD_PIN5CTRL	= PORT_SRLEN_bm; /* RS 	 */		
	PORTD_PIN6CTRL	= PORT_SRLEN_bm; /* WR   */ 	
	PORTD_PIN7CTRL	= PORT_SRLEN_bm; /* RD   */ 		
	PORTD_OUT 		= 0b00000000; 

	PR.PRPD= PR_TC1_bm | PR_TC0_bm | PR_SPI_bm | PR_USART1_bm | PR_USART0_bm;	


	/*  E - LCD */
	PORTE_DIR  		= 0b00000000;
	PORTE_PIN0CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN1CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN2CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN3CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN4CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN5CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN6CTRL	= PORT_SRLEN_bm;	
	PORTE_PIN7CTRL	= PORT_SRLEN_bm;	
	PORTE_OUT 		= 0b00000000;

	PR.PRPE= PR_TC0_bm;	

	/*  F - LCD */
	PORTF_DIR  		= 0b00000000;
	PORTF_PIN0CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN1CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN2CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN3CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN4CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN5CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN6CTRL	= PORT_SRLEN_bm;	
	PORTF_PIN7CTRL	= PORT_SRLEN_bm;	
	PORTF_OUT 		= 0b00000000;

	PR.PRPF= PR_TC0_bm;	



	/* Configure DMA. */
	DMA_CTRL=DMA_ENABLE_bm | DMA_PRIMODE_gm;


	/* Enable low level interrupts. */
	PMIC.CTRL 		= PMIC_LOLVLEN_bm | PMIC_MEDLVLEN_bm  | PMIC_HILVLEN_bm;
	sei( );
}
