#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "integer.h"
#include "lcd_io.h"


volatile static BYTE pwr_intr;
extern volatile UINT TimerSt;

void delay (BYTE dly);
 
void pwr_save()
{

	lcd_ledoff();
	lcd_enter_pwrsave();

	set_sleep_mode(SLEEP_SMODE_PDOWN_gc);

	cli();
	PORTA_DIR  		= (PORTA_DIR & 0b11000011) | 0b00101000;
	PORTA_PIN2CTRL	= PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;  	
	PORTA_OUTCLR	= 0b00101000;

	sleep_enable();
	sei();
	delay (200);

	PORTA_INT0MASK=0b00000100;
	pwr_intr=1;


	sleep_cpu();

	while (pwr_intr);	

	while (!(PORTA_IN & 0b00000100));	

	sleep_disable();

	PORTA_PIN2CTRL	= PORT_OPC_PULLDOWN_gc;	
	lcd_exit_pwrsave();
	lcd_ledon();
}


ISR(PORTA_INT0_vect)
{
	PORTA_INT0MASK=0b00000000;
	pwr_intr=0;
}
